.386
.model flat,stdcall
option casemap:none

include     \masm32\include\windows.inc
include     \masm32\include\kernel32.inc
include     \masm32\include\user32.inc
include     \masm32\include\masm32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib  \masm32\lib\masm32.lib

.data
numbers         dd 1,2,3,4,5        ; we define an array to handle easily the sequence of numbers
message         db 'Sum = %d',0     ; %d will be replaced by the sum of the array members
errmsg          db 'The value you are entering must not be greater than 5',13,10,13,10,0

.data?
buffer          db 100 dup(?)       ; we allocate an uninitialized data block of 100 bytes
                                ; to store the final state of the "message" string processed
                                ; by wsprintf - 100 is an arbitrary value, you could set the
                                ; value depending on the exact final size of "message"
input_buffer    db 100 dup(?)

.code

start:
    invoke  StdIn,ADDR input_buffer,100 ; receive input from keyboard
                                        ; notice that StdIn will write the CR+LF pair to the buffer
    sub     eax,2
    mov     BYTE PTR [input_buffer+eax],0 ; stripping the CR+LF pair, ASCII 13,10
    invoke  atodw,ADDR input_buffer     ; atodw converts a decimal string to dword   
    cmp     eax,5                       ; check the return value stored in eax
    jbe     @f                          ; if eax<=5 then jump to the nearest next anonymous label
    invoke  StdOut,ADDR errmsg          ; eax greater than 5? Display an error message and
    jmp     start                       ; go back to receive another input

@@:
    mov     edx,OFFSET numbers  ; we set a pointer to the array of 5 integers
                                ; "OFFSET numbers" holds the address of the array
                                ; mov edx,numbers -> edx will be simply set to "1" , the value
                                ; of the first array member
    mov     ecx,eax
    xor     eax,eax
@@:
    add     eax,DWORD PTR [edx] ; DWORD PTR [edx] retrieves the value of each integer, edx points
                                ; the address of the array
    add     edx,4               ; edx is a full 32-bit register, so we have to increment edx by 4
                               
    dec     ecx                 ; if ecx == 0 then the ZERO flag is set to TRUE
    jnz     @b                  ; after dec ecx, jump to the nearest anonymous label @@ if the
                                ; ZERO flag is FALSE
    invoke  wsprintf,ADDR buffer,ADDR message,eax
                                ; %d is the only parameter specified in the definition of "message"
                                ; eax holds the sum and wsprintf will dump the the string "Sum = 15"
                                ; to the temporary memory block named "buffer"
    invoke  StdOut,ADDR buffer  ; StdOut prints text to the console, wsprintf writes the formatted string specified by
                                ; "message" to the memory block pointed by ADDR buffer
    invoke  ExitProcess,0       

END start